;PhysicEngine_3_Draw.au3

#include <GDIPlus.au3>
#include <PhysicEngine_3_Polygon.au3>
#include <PhysicEngine_3_Circle.au3>

Enum $TEXTURE_HANDLE, $TEXTURE_WIDTH, $TEXTURE_HEIGHT

Global Const $COLOR_RED    = 0xFFFF0000
Global Const $COLOR_GREEN  = 0xFFFF0000
Global Const $COLOR_BLUE   = 0xFFFF0000
Global Const $COLOR_YELLOW = 0xFFFF0000
Global Const $COLOR_BLACK  = 0xFFFF0000
Global Const $COLOR_WHITE  = 0xFFFF0000

Global Const $SRCCOPY = 0x00CC0020

Global $g_hWindow = 0

Global $g_hDC = 0
Global $g_hGraphic = 0

Global $g_hDummyBitmap = 0
Global $g_hImage = 0
Global $g_hBitmap = 0

Global $g_hScrDC  = 0
Global $g_Backbuffer_hDC = 0
Global $g_DC_obj = 0
Global $g_hBackbuffer = 0

Global $g_hFGBitmap = 0
Global $g_hFGBackbuffer = 0

Global $g_hPen = 0
Global $g_hBrush = 0
Global $g_hFont = 0
Global $g_hFormat = 0

Global $g_FGBitmapSize[2] = [2048,2048]

Global $g_Window_X
Global $g_Window_Y
Global $g_Window_Width
Global $g_Window_Height
Global $g_Window_Title

Global Const $g_StandartFont = "Arial"
Global $g_ClearColor = 0xFFFFFFFF

Func phys_StartupDraw()
	_GDIPlus_Startup()	
	
	$g_hPen = _GDIPlus_PenCreate (0xFF000000,1)
	$g_hBrush = _GDIPlus_BrushCreateSolid(0xFFABCDEF)
	Local $hFamily = _GDIPlus_FontFamilyCreate($g_StandartFont)
	$g_hFont = _GDIPlus_FontCreate($hFamily, 8) 				; font size
		_GDIPlus_FontFamilyDispose($hFamily)
	$g_hFormat = _GDIPlus_StringFormatCreate(0) 				; format
EndFunc

Func phys_ShutdownDraw()
	_GDIPlus_StringFormatDispose($g_hFormat)
	_GDIPlus_FontDispose($g_hFont)
	_GDIPlus_BrushDispose($g_hBrush)
	_GDIPlus_PenDispose($g_hPen)

	_GDIPlus_Shutdown()
EndFunc

Func phys_CreateWindow( $title, $width, $height, $x = -1, $y = -1 )
	$g_hWindow = GUICreate( $title, $width, $height,$x,$y)
		GUISetOnEvent(-3, "_phys_Exit") 
	GUISetState(@SW_SHOW)

	;GUISetCursor(3) ; cross
	GUISetCursor(16, 1, $g_hWindow) ; invisible

	$g_hDC = _WinAPI_GetWindowDC($g_hWindow)
	$g_hGraphic = _GDIPlus_GraphicsCreateFromHDC($g_hDC)

	$g_hDummyBitmap = _WinAPI_CreateBitmap($width, $height) 
	$g_hImage = _GDIPlus_BitmapCreateFromHBITMAP($g_hDummyBitmap)
	$g_hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($g_hImage)

	$g_hScrDC  = _WinAPI_GetDC(0)
	$g_Backbuffer_hDC  = _WinAPI_CreateCompatibleDC($g_hScrDC)
	$g_DC_obj = _WinAPI_SelectObject($g_Backbuffer_hDC, $g_hBitmap)
	$g_hBackbuffer = _GDIPlus_GraphicsCreateFromHDC($g_Backbuffer_hDC)
	
	$g_FGBitmapSize[0] = $width
	$g_FGBitmapSize[1] = $height
	
	$g_hFGBitmap = _GDIPlus_BitmapCreateFromGraphics($g_FGBitmapSize[0],$g_FGBitmapSize[1], $g_hGraphic) 
	$g_hFGBackbuffer = _GDIPlus_ImageGetGraphicsContext($g_hFGBitmap)
	
	$g_Window_X = $x
	$g_Window_Y = $y
	$g_Window_Width = $width
	$g_Window_Height = $height
	$g_Window_Title = $title
	
	phys_SwapBuffers()
EndFunc

Func _phys_Exit()
	Exit 0
EndFunc

Func phys_CreateTexture( $filename )
	Local $ImageFromFile_Handle = _GDIPlus_ImageLoadFromFile($filename) ; load image from file / bild aus datei laden
	
	Local $ImageFromFile_Width = _GDIPlus_ImageGetWidth($ImageFromFile_Handle)
	Local $ImageFromFile_Height = _GDIPlus_ImageGetWidth($ImageFromFile_Handle)
	
	Local $aResult = DllCall($ghGDIPDll, "uint", "GdipCreateTexture2", "hwnd", $ImageFromFile_Handle, "int", 0, "float", 0, "float", 0, "float", $ImageFromFile_Width, "float", $ImageFromFile_Height, "int*", 0)
	
	_GDIPlus_ImageDispose($ImageFromFile_Handle)
	
	If @error Then Return SetError(@error, @extended, 0)
	
	Dim $Texture[3] 
	
	$Texture[$TEXTURE_HANDLE] = $aResult[7]
	$Texture[$TEXTURE_WIDTH]  = $ImageFromFile_Width
	$Texture[$TEXTURE_HEIGHT] = $ImageFromFile_Height
	
	Return $Texture
EndFunc

Func phys_CreateTextureColor( $color )
	Dim $Texture[3] 
	
	$Texture[$TEXTURE_HANDLE] = _GDIPlus_BrushCreateSolid($color)
	$Texture[$TEXTURE_WIDTH]  = 256
	$Texture[$TEXTURE_HEIGHT] = 256
	
	Return $Texture
EndFunc

Func phys_TextureGetWidth( ByRef $texture )
	Return $texture[$TEXTURE_WIDTH]
EndFunc

Func phys_TextureGetHeight( ByRef $texture )
	Return $texture[$TEXTURE_HEIGHT]
EndFunc

Func phys_TextureGetHandle( ByRef $texture )
	return $texture[$TEXTURE_HANDLE]
EndFunc

Func _phys_CreateObjectMatrix( ByRef $texture )
	Local $Matrix _GDIPlus_MatrixCreate()
	
	_GDIPlus_MatrixTranslate($Matrix, 0.5 * phys_TextureGetWidth( $texture ), 0.5 * phys_TextureGetHeight( $texture ))
	
	Return $Matrix
EndFunc

Func phys_DrawPolygon( $polygon_id )
	
	Local $NumPoints = $g_Polygons_NumPoints[$polygon_id] 
	Local $NumElements = 2 * $NumPoints
	
	Local $tPoints = DllStructCreate("int[" & $NumElements & "]") 			
	Local $pPoints = DllStructGetPtr($tPoints)
	
	For $i = 0 To $NumElements - 1 Step 1
		DllStructSetData($tPoints, 1, $g_Polygons_Points[$polygon_id][$i], $i+1)
	Next

	_GDIPlus_GraphicsClear($g_hFGBackbuffer, 0x0)

	Local $hMatrix = _GDIPlus_MatrixCreate()
	
	_GDIPlus_MatrixTranslate($hMatrix, $g_FGBitmapSize[0]/2, $g_FGBitmapSize[1]/2)
	_GDIPlus_MatrixRotate($hMatrix, $g_Polygons_Angle[$polygon_id] * $RAD_TO_DEG, False)
	
	_GDIPlus_GraphicsSetTransform($g_hFGBackbuffer, $hMatrix)
	
	Local $texture = $g_Polygons_Texture[$polygon_id]
	
	DllCall($ghGDIPDll, "int", "GdipFillPolygonI", "hWnd", $g_hFGBackbuffer, "hWnd", $texture[$TEXTURE_HANDLE], "ptr", $pPoints, "int", $NumPoints, "int", "FillModeAlternate")
	
	_GDIPlus_MatrixDispose($hMatrix)	
	
	;TODO
	
	_GDIPlus_GraphicsDrawImageRect($g_hBackbuffer, $g_hFGBitmap, $g_Polygons_Position_X[$polygon_id]-$g_FGBitmapSize[0]/2, $g_Polygons_Position_Y[$polygon_id]-$g_FGBitmapSize[1]/2, $g_FGBitmapSize[0], $g_FGBitmapSize[1]) ;copy foreground backbuffer to main backbuffer
	
	For $i = 0 To $NumElements - 1 Step 1
		DllStructSetData($tPoints, 1, $g_Polygons_Points_Translated[$polygon_id][$i], $i+1)
	Next
	
	DllCall($ghGDIPDll, "int", "GdipDrawPolygonI", "handle", $g_hBackbuffer, "handle", $g_hPen, "ptr", $pPoints, "int", $NumPoints)
	
EndFunc

Func phys_DrawCircle( $circle_id )
	
	_GDIPlus_GraphicsClear($g_hFGBackbuffer, 0x0)

	Local $hMatrix = _GDIPlus_MatrixCreate()
	
	_GDIPlus_MatrixTranslate($hMatrix, $g_FGBitmapSize[0]/2, $g_FGBitmapSize[1]/2)
	_GDIPlus_MatrixRotate($hMatrix, $g_Circles_Angle[$circle_id] * $RAD_TO_DEG, False)
	
	_GDIPlus_GraphicsSetTransform($g_hFGBackbuffer, $hMatrix)
	
	Local $texture = $g_Polygons_Texture[$circle_id]
	
	DllCall($ghGDIPDll, "int", "GdipFillEllipseI", "handle", $g_hFGBackbuffer, "handle", $texture[$TEXTURE_HANDLE], "int", -$g_Circles_Radius[$circle_id], "int", -$g_Circles_Radius[$circle_id], "int", $g_Circles_Radius[$circle_id]*2, "int", $g_Circles_Radius[$circle_id]*2)
	
	_GDIPlus_MatrixDispose($hMatrix)
	
	_GDIPlus_GraphicsDrawImageRect($g_hBackbuffer, $g_hFGBitmap, $g_Circles_Position_X[$circle_id]-$g_FGBitmapSize[0]/2, $g_Circles_Position_Y[$circle_id]-$g_FGBitmapSize[1]/2, $g_FGBitmapSize[0], $g_FGBitmapSize[1]) ;copy foreground backbuffer to main backbuffer

	DllCall($ghGDIPDll, "int", "GdipDrawEllipseI", "handle", $g_hBackbuffer, "handle", $g_hPen, "int", $g_Circles_Position_X[$circle_id]-$g_Circles_Radius[$circle_id], "int", $g_Circles_Position_Y[$circle_id]-$g_Circles_Radius[$circle_id], "int", $g_Circles_Radius[$circle_id]*2, "int", $g_Circles_Radius[$circle_id]*2)

EndFunc

Func phys_ClearBackbuffer()
	_GDIPlus_GraphicsClear($g_hBackbuffer,$g_ClearColor)
EndFunc

Func phys_SwapBuffers()
	_WinAPI_BitBlt($g_hDC, 3, 23, $g_Window_Width, $g_Window_Height, $g_Backbuffer_hDC, 0, 0, $SRCCOPY) ;$SRCCOPY = 0x00CC0020
EndFunc
