;PhysikEngine_3_Polygon.au3

#include <PhysicEngine_3_Math.au3>

Global $g_NumPolygons = 0

Global $g_Polygons_NumPoints[1]
Global $g_Polygons_Points_Update[1]
Global $g_Polygons_Points[1][1]
Global $g_Polygons_Points_Translated[1][1]
Global $g_Polygons_Position_X[1]
Global $g_Polygons_Position_Y[1]
Global $g_Polygons_Angle[1]
Global $g_Polygons_Velocity_Linear_X[1]
Global $g_Polygons_Velocity_Linear_Y[1]
Global $g_Polygons_Velocity_Angular[1]
Global $g_Polygons_Acceleration_Linear_X[1]
Global $g_Polygons_Acceleration_Linear_Y[1]
Global $g_Polygons_Acceleration_Angular[1]
Global $g_Polygons_Force_Linear_X[1]
Global $g_Polygons_Force_Linear_Y[1]
Global $g_Polygons_Force_Angular[1]
Global $g_Polygons_Mass[1]
Global $g_Polygons_Tensor[1]
Global $g_Polygons_Collision_Frequency[1]
Global $g_Polygons_Box_X_Min[1]
Global $g_Polygons_Box_X_Max[1]
Global $g_Polygons_Box_Y_Min[1]
Global $g_Polygons_Box_Y_Max[1]
Global $g_Polygons_Radius[1]
Global $g_Polygons_Color[1]
Global $g_Polygons_Texture[1]
Global $g_Polygons_Position_X_Last[1]
Global $g_Polygons_Position_Y_Last[1]
Global $g_Polygons_Angle_Last[1]
Global $g_Polygons_Time_Without_Move[1]
Global $g_Polygons_Sleep[1]

Func phys_CreatePolygon( ByRef $points, $position_x, $position_y, $angle, $velocity_linear_x, $velocity_linear_y, $velocity_angular, $mass, $tensor, $collision_fequency, $color, ByRef $texture )
		
	; redim arrays
		
	$g_NumPolygons += 1;			// increase number of polygons / number der vielecke erhhen
	
	Local $NumElements = UBound( $points )
	Local $NumPoints = $NumElements / 2
	
	ReDim $g_Polygons_NumPoints[$g_NumPolygons]
	ReDim $g_Polygons_Points_Update[$g_NumPolygons]
	ReDim $g_Polygons_Points[$g_NumPolygons][$NumElements]
	ReDim $g_Polygons_Points_Translated[$g_NumPolygons][$NumElements]
	ReDim $g_Polygons_Position_X[$g_NumPolygons]
	ReDim $g_Polygons_Position_Y[$g_NumPolygons]
	ReDim $g_Polygons_Angle[$g_NumPolygons]
	ReDim $g_Polygons_Velocity_Linear_X[$g_NumPolygons]
	ReDim $g_Polygons_Velocity_Linear_Y[$g_NumPolygons]
	ReDim $g_Polygons_Velocity_Angular[$g_NumPolygons]
	ReDim $g_Polygons_Acceleration_Linear_X[$g_NumPolygons]
	ReDim $g_Polygons_Acceleration_Linear_Y[$g_NumPolygons]
	ReDim $g_Polygons_Acceleration_Angular[$g_NumPolygons]
	ReDim $g_Polygons_Force_Linear_X[$g_NumPolygons]
	ReDim $g_Polygons_Force_Linear_Y[$g_NumPolygons]
	ReDim $g_Polygons_Force_Angular[$g_NumPolygons]
	ReDim $g_Polygons_Mass[$g_NumPolygons]
	ReDim $g_Polygons_Tensor[$g_NumPolygons]
	ReDim $g_Polygons_Collision_Frequency[$g_NumPolygons]
	ReDim $g_Polygons_Box_X_Min[$g_NumPolygons]
	ReDim $g_Polygons_Box_X_Max[$g_NumPolygons]
	ReDim $g_Polygons_Box_Y_Min[$g_NumPolygons]
	ReDim $g_Polygons_Box_Y_Max[$g_NumPolygons]
	ReDim $g_Polygons_Radius[$g_NumPolygons]
	ReDim $g_Polygons_Color[$g_NumPolygons]
	ReDim $g_Polygons_Texture[$g_NumPolygons]
	ReDim $g_Polygons_Position_X_Last[$g_NumPolygons]
	ReDim $g_Polygons_Position_Y_Last[$g_NumPolygons]
	ReDim $g_Polygons_Angle_Last[$g_NumPolygons]
	ReDim $g_Polygons_Time_Without_Move[$g_NumPolygons]
	ReDim $g_Polygons_Sleep[$g_NumPolygons]
	
	; set polygon
		
	Local $PolygonID = $g_NumPolygons - 1
	
	$g_Polygons_NumPoints[$PolygonID] = $NumPoints
	$g_Polygons_Points_Update[$PolygonID] = True
	For $j = 0 To $NumElements - 1 Step 1
		$g_Polygons_Points[$PolygonID][$j] = $points[$j]														; copy points / punkte kopieren
		$g_Polygons_Points_Translated[$PolygonID][$j] = 0														; init to zero
	Next
	
	Local $Radius_Square = 0
	
	For $j = 0 To $NumElements - 1 Step 2
		Local $New_Radius_Square = $points[$j] * $points[$j] + $points[$j+1] * $points[$j+1]			; calculate maximun radius square / den maximalen radius berechnen
		If $New_Radius_Square > $Radius_Square Then $Radius_Square = $New_Radius_Square
	Next
	
	Local $Radius = Sqrt($Radius_Square)
	
	$g_Polygons_Position_X[$PolygonID] = $position_x
	$g_Polygons_Position_Y[$PolygonID] = $position_y
	$g_Polygons_Angle[$PolygonID] = $angle
	$g_Polygons_Velocity_Linear_X[$PolygonID] = $velocity_linear_x
	$g_Polygons_Velocity_Linear_Y[$PolygonID] = $velocity_linear_y
	$g_Polygons_Velocity_Angular[$PolygonID] = $velocity_angular
	$g_Polygons_Acceleration_Linear_X[$PolygonID] = 0
	$g_Polygons_Acceleration_Linear_Y[$PolygonID] = 0
	$g_Polygons_Acceleration_Angular[$PolygonID] = 0
	$g_Polygons_Force_Linear_X[$PolygonID] = 0
	$g_Polygons_Force_Linear_Y[$PolygonID] = 0
	$g_Polygons_Force_Angular[$PolygonID] = 0
	$g_Polygons_Mass[$PolygonID] = $mass
	$g_Polygons_Tensor[$PolygonID] = $tensor
	$g_Polygons_Collision_Frequency[$PolygonID] = $collision_fequency
	$g_Polygons_Box_X_Min[$PolygonID] = $position_x
	$g_Polygons_Box_X_Max[$PolygonID] = $position_x
	$g_Polygons_Box_Y_Min[$PolygonID] = $position_y
	$g_Polygons_Box_Y_Max[$PolygonID] = $position_y
	$g_Polygons_Radius[$PolygonID] = $Radius
	$g_Polygons_Color[$PolygonID] = $color
	$g_Polygons_Texture[$PolygonID] = $texture
	$g_Polygons_Position_X_Last[$PolygonID] = $position_x
	$g_Polygons_Position_Y_Last[$PolygonID] = $position_y
	$g_Polygons_Angle_Last[$PolygonID] = $angle
	$g_Polygons_Time_Without_Move[$PolygonID] = 0
	$g_Polygons_Sleep[$PolygonID] = False
	
	Return $PolygonID	
EndFunc

Func phys_CreateRect( $width, $height, $position_x, $position_y, $angle, $velocity_linear_x, $velocity_linear_y, $velocity_angular, $mass, $tensor, $collision_fequency, $color, ByRef $texture )
	Local $HalfWidth = 0.5 * $width
	Local $HalfHeight = 0.5 * $height
	Local $Points[8] = [-$HalfWidth,-$HalfHeight, $HalfWidth,-$HalfHeight, $HalfWidth, $HalfHeight,-$HalfWidth, $HalfHeight]
	
	Return phys_CreatePolygon( $Points, $position_x, $position_y, $angle, $velocity_linear_x, $velocity_linear_y, $velocity_angular, $mass, $tensor, $collision_fequency, $color, $texture)
EndFunc

Func phys_CopyPolygon( $polygon_id )
	
	Local $NumElements = 2*$g_Polygons_NumPoints[$polygon_id]
	Dim $Points[$NumElements]
	
	For $i = 0 To $NumElements - 1 Step 1
		$Points[$i] = $g_Polygons_Points[$polygon_id][$i]
	Next
	
	Local $texture = $g_Polygons_Texture[$polygon_id]
	
	Return phys_CreatePolygon( $Points, $g_Polygons_Position_X[$polygon_id], $g_Polygons_Position_Y[$polygon_id], $g_Polygons_Angle[$polygon_id], _ 
		$g_Polygons_Velocity_Linear_X[$polygon_id], $g_Polygons_Velocity_Linear_Y[$polygon_id], $g_Polygons_Velocity_Angular[$polygon_id], _ 
		$g_Polygons_Mass[$polygon_id], $g_Polygons_Tensor[$polygon_id], $g_Polygons_Collision_Frequency[$polygon_id], _ 
		$g_Polygons_Color[$polygon_id], $texture )
EndFunc

Func phys_PolygonDelete( $polygon_id )
	
	$g_NumPolygons -= 1
	
	_ArrayDelete( $g_Polygons_NumPoints, $polygon_id )
	_ArrayDelete( $g_Polygons_Points_Update, $polygon_id )
	_ArrayDelete( $g_Polygons_Points, $polygon_id )
	_ArrayDelete( $g_Polygons_Points_Translated, $polygon_id )
	_ArrayDelete( $g_Polygons_Position_X, $polygon_id )
	_ArrayDelete( $g_Polygons_Position_Y, $polygon_id )
	_ArrayDelete( $g_Polygons_Angle, $polygon_id )
	_ArrayDelete( $g_Polygons_Velocity_Linear_X, $polygon_id )
	_ArrayDelete( $g_Polygons_Velocity_Linear_Y, $polygon_id )
	_ArrayDelete( $g_Polygons_Velocity_Angular, $polygon_id )
	_ArrayDelete( $g_Polygons_Acceleration_Linear_X, $polygon_id )
	_ArrayDelete( $g_Polygons_Acceleration_Linear_Y, $polygon_id )
	_ArrayDelete( $g_Polygons_Acceleration_Angular, $polygon_id )
	_ArrayDelete( $g_Polygons_Force_Linear_X, $polygon_id )
	_ArrayDelete( $g_Polygons_Force_Linear_Y, $polygon_id )
	_ArrayDelete( $g_Polygons_Force_Angular, $polygon_id )
	_ArrayDelete( $g_Polygons_Mass, $polygon_id )
	_ArrayDelete( $g_Polygons_Tensor, $polygon_id )
	_ArrayDelete( $g_Polygons_Collision_Frequency, $polygon_id )
	_ArrayDelete( $g_Polygons_Box_X_Min, $polygon_id )
	_ArrayDelete( $g_Polygons_Box_X_Max, $polygon_id )
	_ArrayDelete( $g_Polygons_Box_Y_Min, $polygon_id )
	_ArrayDelete( $g_Polygons_Box_Y_Max, $polygon_id )
	_ArrayDelete( $g_Polygons_Radius, $polygon_id )
	_ArrayDelete( $g_Polygons_Color, $polygon_id )
	_ArrayDelete( $g_Polygons_Texture, $polygon_id )
	
EndFunc

Func phys_UpdatePolygons( $delta_t_s, $damping )
	For $i = 0 To $g_NumPolygons - 1 Step 1 																												; loop all polygons
		If $g_Polygons_Mass[$i] <> 0 Then 																			
			$g_Polygons_Velocity_Linear_X[$i] += $delta_t_s * $g_Polygons_Force_Linear_X[$i] * (1/$g_Polygons_Mass[$i])										; apply forces
			$g_Polygons_Velocity_Linear_Y[$i] += $delta_t_s * $g_Polygons_Force_Linear_Y[$i] * (1/$g_Polygons_Mass[$i])
		EndIf
		If $g_Polygons_Tensor[$i] <> 0 Then 
			$g_Polygons_Velocity_Angular[$i] += $delta_t_s * $g_Polygons_Force_Angular[$i] * (1/$g_Polygons_Tensor[$i])
		EndIf
		
		$g_Polygons_Velocity_Linear_X[$i] *= $damping
		$g_Polygons_Velocity_Linear_Y[$i] *= $damping
		$g_Polygons_Velocity_Angular[$i] *= $damping
		
		$g_Polygons_Force_Linear_X[$i] = 0																													; reset to zero
		$g_Polygons_Force_Linear_Y[$i] = 0
		$g_Polygons_Force_Angular[$i] = 0
	
		$g_Polygons_Position_X[$i] += $delta_t_s * $g_Polygons_Velocity_Linear_X[$i]																		; update position
		$g_Polygons_Position_Y[$i] += $delta_t_s * $g_Polygons_Velocity_Linear_Y[$i]
		$g_Polygons_Angle[$i] += $delta_t_s * $g_Polygons_Velocity_Angular[$i] 																				; update angle
	
		Local $Sin = Sin( $g_Polygons_Angle[$i] )
		Local $Cos = Cos( $g_Polygons_Angle[$i] )
		
		For $j = 0 To 2 * $g_Polygons_NumPoints[$i] - 1 Step 2																								; loop all points
			$g_Polygons_Points_Translated[$i][$j  ] = $g_Polygons_Position_X[$i] + $Cos * $g_Polygons_Points[$i][$j] - $Sin * $g_Polygons_Points[$i][$j+1]
			$g_Polygons_Points_Translated[$i][$j+1] = $g_Polygons_Position_Y[$i] + $Sin * $g_Polygons_Points[$i][$j] + $Cos * $g_Polygons_Points[$i][$j+1]
		Next
	Next
EndFunc

Func phys_PolygonsApplyForces( $delta_t_s )
	For $i = 0 To $g_NumPolygons - 1 Step 1 																												; loop all polygons
		If Not $g_Polygons_Sleep[$i] Then
			If $g_Polygons_Mass[$i] <> 0 Then 																			
				$g_Polygons_Velocity_Linear_X[$i] += $delta_t_s * $g_Polygons_Force_Linear_X[$i] * (1/$g_Polygons_Mass[$i])									; apply forces
				$g_Polygons_Velocity_Linear_Y[$i] += $delta_t_s * $g_Polygons_Force_Linear_Y[$i] * (1/$g_Polygons_Mass[$i])
			EndIf
			If $g_Polygons_Tensor[$i] <> 0 Then 
				$g_Polygons_Velocity_Angular[$i] += $delta_t_s * $g_Polygons_Force_Angular[$i] * (1/$g_Polygons_Tensor[$i])
			EndIf
		EndIf
		
		$g_Polygons_Force_Linear_X[$i] = 0																													; reset to zero
		$g_Polygons_Force_Linear_Y[$i] = 0
		$g_Polygons_Force_Angular[$i] = 0
	Next
EndFunc

Func phys_PolygonsUpdatePosition( $delta_t_s, $damping, $limit_sleep_pos_sq, $limit_sleep_angle, $limit_sleep_time )
	For $i = 0 To $g_NumPolygons - 1 Step 1 																												; loop all polygon
		If Not $g_Polygons_Sleep[$i] Then
			$g_Polygons_Velocity_Linear_X[$i] *= $damping
			$g_Polygons_Velocity_Linear_Y[$i] *= $damping
			$g_Polygons_Velocity_Angular[$i] *= $damping
			
			$g_Polygons_Position_X[$i] += $delta_t_s * $g_Polygons_Velocity_Linear_X[$i]																		; update position
			$g_Polygons_Position_Y[$i] += $delta_t_s * $g_Polygons_Velocity_Linear_Y[$i]
			$g_Polygons_Angle[$i] += $delta_t_s * $g_Polygons_Velocity_Angular[$i] 																				; update angle
			
			Local $DeltaX = $g_Polygons_Position_X_Last[$i] - $g_Polygons_Position_X[$i]
			Local $DeltaY = $g_Polygons_Position_Y_Last[$i] - $g_Polygons_Position_Y[$i]
			Local $DistanceSQ = $DeltaX*$DeltaX + $DeltaY*$DeltaY
			Local $DeltaAngle = Abs( $g_Polygons_Angle_Last[$i] - $g_Polygons_Angle[$i])
			
			If ($DistanceSQ > $limit_sleep_pos_sq) Or ($DeltaAngle > $limit_sleep_angle) Then
				phys_PolygonWake( $i )
			Else
				If $g_Polygons_Time_Without_Move[$i] >= $limit_sleep_time Then 
					$g_Polygons_Sleep[$i] = True
				Else
					$g_Polygons_Time_Without_Move[$i] += $delta_t_s				
				EndIf
			EndIf
		EndIf
	Next
EndFunc

Func phys_PolygonsUpdatePoints()
	For $i = 0 To $g_NumPolygons - 1 Step 1 																												; loop all polygons
		Local $Sin = Sin( $g_Polygons_Angle[$i] )
		Local $Cos = Cos( $g_Polygons_Angle[$i] )
		
		For $j = 0 To 2 * $g_Polygons_NumPoints[$i] - 1 Step 2																								; loop all points
			$g_Polygons_Points_Translated[$i][$j  ] = $g_Polygons_Position_X[$i] + $Cos * $g_Polygons_Points[$i][$j] - $Sin * $g_Polygons_Points[$i][$j+1]
			$g_Polygons_Points_Translated[$i][$j+1] = $g_Polygons_Position_Y[$i] + $Sin * $g_Polygons_Points[$i][$j] + $Cos * $g_Polygons_Points[$i][$j+1]
		Next
	Next
EndFunc

Func phys_PolygonAddForcePoint( $polygon_id, $point_x, $point_y, $force_x, $force_y )

	Local $DeltaX = $point_x - $g_Polygons_Position_X[$polygon_id]
	Local $DeltaY = $point_y - $g_Polygons_Position_Y[$polygon_id]
	Local $Radius = Sqrt($DeltaX * $DeltaX + $DeltaY * $DeltaY)
	
	If $Radius = 0 Then														; force is appied to center of polygon
		$g_Polygons_Force_Linear_X[$polygon_id] += $force_x
		$g_Polygons_Force_Linear_Y[$polygon_id] += $force_y
	Else
		Local $ForceLength = Sqrt($force_x * $force_x + $force_y * $force_y)
		If $ForceLength = 0 Then $ForceLength = 1
		
		Local $ForceNoramlizedX = $force_x / $ForceLength
		Local $ForceNoramlizedY = $force_y / $ForceLength
		
		Local $RadiusNormalizedX = $DeltaX / $Radius
		Local $RadiusNormalizedY = $DeltaY / $Radius
		
		Local $Lambda = $ForceNoramlizedX * $RadiusNormalizedX + $ForceNoramlizedY * $RadiusNormalizedY
		Local $LambdaAbs = Abs($Lambda)
		
		Local $ForceLinearX = $LambdaAbs * $force_x
		Local $ForceLinearY = $LambdaAbs * $force_y
		Local $ForceAngular = (1-$LambdaAbs) * $DeltaX * $force_y - $DeltaY * $force_x
		
		;ToolTip( "LinearForce: " & $ForceLinearX & " " & $ForceLinearY & " AngularForce: " & $ForceAngular )
		
		$g_Polygons_Force_Linear_X[$polygon_id] += $ForceLinearX
		$g_Polygons_Force_Linear_Y[$polygon_id] += $ForceLinearY		
		$g_Polygons_Force_Angular[$polygon_id] += $ForceAngular
	EndIf
EndFunc

Func phys_PolygonAddForceCenter( $polygon_id, $force_x, $force_y )
		$g_Polygons_Force_Linear_X[$polygon_id] += $force_x
		$g_Polygons_Force_Linear_Y[$polygon_id] += $force_y
EndFunc

Func phys_IsPointInPolygon( $polygon_id, $point_x, $point_y )
		
	If Not phys_IsPointInPolygonRadius( $polygon_id, $point_x, $point_y ) Then Return False
	
	Local $InfiniteLine[4] = [$point_x, $point_y, $point_x + 100000, $point_y + 100000]
	
	Local $NumIntersectionPoints = 0
	
	Local $NumElements = 2*$g_Polygons_NumPoints[$polygon_id]
	
	For $i = 0 To $NumElements - 1 Step 2
		Local $ii = Mod( $i+2, $NumElements )
		
		Local $IntersectionPoint[2]
		
		If phys_LinesIntersect( _ 
			$g_Polygons_Points_Translated[$polygon_id][$i ], $g_Polygons_Points_Translated[$polygon_id][$i +1], _ 
			$g_Polygons_Points_Translated[$polygon_id][$ii], $g_Polygons_Points_Translated[$polygon_id][$ii+1], _ 
			$InfiniteLine[0], $InfiniteLine[1], $InfiniteLine[2], $InfiniteLine[3], _ 
			$IntersectionPoint ) Then
			
			$NumIntersectionPoints += 1			
		EndIf		
	Next
	
	Return (Mod( $NumIntersectionPoints, 2 ) = 1)
EndFunc

Func phys_IsPointInPolygonRadius( $polygon_id, $point_x, $point_y )
	Return phys_PointInCircle( $point_x, $point_y, $g_Polygons_Position_X[$polygon_id], $g_Polygons_Position_Y[$polygon_id], $g_Polygons_Radius[$polygon_id] )
EndFunc

Func phys_PolygonFromPoint( $point_x, $point_y, ByRef $polygon_id )
	
	$polygon_id = -1
	
	For $i = 0 To $g_NumPolygons - 1 Step 1			
		If phys_IsPointInPolygon( $i, $point_x, $point_y ) Then 
			$polygon_id = $i
			Return True
		EndIf
	Next
	
	Return False
EndFunc

Func phys_PolygonGetRadiusPoint( $polygon_id, $point_x, $point_y )
	Dim $Radius[2]

	$Radius[0] = $point_x - $g_Polygons_Position_X[$polygon_id]
	$Radius[1] = $point_y - $g_Polygons_Position_Y[$polygon_id]
	
	Return $Radius
EndFunc

Func phys_PolygonStop( $polygon_id )
	$g_Polygons_Velocity_Linear_X[$polygon_id] = 0
	$g_Polygons_Velocity_Linear_Y[$polygon_id] = 0
	$g_Polygons_Velocity_Angular[$polygon_id] = 0
EndFunc

Func phys_PolygonScale( $polygon_id, $scale_x, $scale_y )
	
	Local $NumElements = 2 * $g_Polygons_NumPoints[$polygon_id]
	
	For $i = 0 To $NumElements - 1 Step 2
		$g_Polygons_Points[$polygon_id][$i  ] = $scale_x * $g_Polygons_Points[$polygon_id][$i  ]
		$g_Polygons_Points[$polygon_id][$i+1] = $scale_y * $g_Polygons_Points[$polygon_id][$i+1]
	Next
	
EndFunc

Func phys_PolygonSleep( $polygon_id )
	$g_Polygons_Sleep[$polygon_id] = True
EndFunc

Func phys_PolygonWake( $polygon_id )
	If ($g_Polygons_Mass[$polygon_id] <> 0) Or ($g_Polygons_Tensor[$polygon_id] <> 0) Then
		$g_Polygons_Position_X_Last[$polygon_id] = $g_Polygons_Position_X[$polygon_id]
		$g_Polygons_Position_Y_Last[$polygon_id] = $g_Polygons_Position_Y[$polygon_id]
		$g_Polygons_Angle_Last[$polygon_id] = $g_Polygons_Angle[$polygon_id]
		$g_Polygons_Time_Without_Move[$polygon_id] = 0
		$g_Polygons_Sleep[$polygon_id] = False
	EndIf
EndFunc

Func phys_PolygonGetInfomations( $polygon_id )
		
	Return _ 
		"Informations Polygon " & $polygon_id & ":" & @LF & @LF & _ 
		"   + Position: " & Round( $g_Polygons_Position_X[$polygon_id], 0 ) & " " & Round( $g_Polygons_Position_Y[$polygon_id], 0 ) & @LF & _ 
		"   + Angle: " & Round( $g_Polygons_Angle[$polygon_id] * $RAD_TO_DEG, 0 ) & "" & @LF & _
		"   + VelocityLinear: " & Round( $g_Polygons_Velocity_Linear_X[$polygon_id], 0 ) & " " & Round( $g_Polygons_Velocity_Linear_Y[$polygon_id], 0 ) & @LF & _ 
		"   + VelocityAngular: " & Round( $g_Polygons_Velocity_Angular[$polygon_id] * $RAD_TO_DEG, 0 ) & "/s" & @LF & _ 
		"   + TimeWithoutMove: " & Round(  $g_Polygons_Time_Without_Move[$polygon_id], 0 ) & "s" & @LF & _ 
		"   + Sleep: " & $g_Polygons_Sleep[$polygon_id]
EndFunc