#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.0.0
 Author:         Moritz1243

 Script Function:
    Template AutoIt script.

#ce ----------------------------------------------------------------------------

#include <Array.au3>
#include <PhysicEngine_3.au3>

Opt('MustDeclareVars', 1)
Opt('GuiOnEventMode', 1)
Opt('MouseCoordMode', 0)

phys_Startup()

Global $Window = phys_CreateWindow( "PhysicEngine 3", 1280, 600, -1, -1 )

phys_CreateDebugWindow()

Local $points[6] = [-50,-50, 50, -50, 0, 50]
Local $position_x = 100
Local $position_y = 200
Local $angle = 0.2
Local $texture_gray_static = phys_CreateTextureColor(0xFF666666)
Local $texture_gray_dynamic = phys_CreateTextureColor(0xFFCCCCCC)
Local $texture_green = phys_CreateTextureColor(0xFF00FF00)					; alternativ phys_CreateTexture( filename )
Local $mass = 2
Local $tensor = 5000
Local $collision_fequency = 1

phys_CreatePolygon( $points, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_dynamic )

$position_x = 500
$position_y = 160

phys_CreatePolygon( $points, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_dynamic )

$position_x = 190
$position_y = 160

phys_CreatePolygon( $points, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_dynamic )

Local $radius = 40
$position_x = 240
$position_y = 200

phys_CreateCircle( $radius, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_dynamic )

$radius = 10
$position_x = 500
$position_y = 200

phys_CreateCircle( $radius, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_dynamic )

Local $width = 300
Local $height = 50

$angle = 0
$position_x = 500
$position_y = 225

For $i = 0 To 0 Step 1
	$position_y += 50

	phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_dynamic )
Next

$width = 1200
$height = 200
$position_x = 640
$position_y = 600
$mass = 0
$tensor = 0

phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_static )

$height = 50
$position_y = 75

phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_static )

$width = 50
$height = 400
$position_x = 65
$position_y = 300

phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_static )

$position_x = 1215

phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_static )

$position_x = 1020
$position_y = 265
$angle = 90 * $DEG_TO_RAD

phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_static )

$angle = 45 * $DEG_TO_RAD

$position_x = 700
$position_y = 400

phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_gray_static )

$angle = 0
$mass = 2
$width = 10
$height = 40
$position_x = 400
$position_y = 450

Global $PlayerID = phys_CreateRect( $width, $height, $position_x, $position_y, $angle, 0, 0, 0 * $DEG_TO_RAD, $mass, $tensor, $collision_fequency, $COLOR_WHITE, $texture_green )

Global $g_point
Global $g_mtd

; /new --------------------------------
Global $TimerJump = _Timer_Init()
Global $TimerJump_Last = _Timer_Diff($TimerJump)

While Sleep(10)
	Local $ForceMove = 1000
	Local $ForceJump = 10000	
	Local $JumpInterval = 1000
	Local $TimeDiff = _Timer_Diff($TimerJump)	
	
	phys_PolygonWake( $PlayerID )
	
	If _IsPressed( "25" ) Then phys_PolygonAddForceCenter( $PlayerID, -$ForceMove, 0 )
	If _IsPressed( "27" ) Then phys_PolygonAddForceCenter( $PlayerID, $ForceMove, 0 )
	If _IsPressed( "26" ) And ($TimeDiff - $TimerJump_Last > $JumpInterval) Then
		$TimerJump_Last = $TimeDiff
		
		phys_PolygonAddForceCenter( $PlayerID, 0, -$ForceJump )
	EndIf
	
    phys_Frame()
WEnd


